<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

Example(title='SSVG IFrame Example' :maxState="2")
  template(v-slot:description)
    h5 This is an SSVG IFrame example
    p
      | Integrating an SSVG in an IFrame isolates it from main DOM and CSS,
      | depending on the document it can protect filters gradients and other
      | SVG artifacts that are referenced using #[tt id] attributes.
    p
      | Iframes create a completely new context and have a direct effect on overall
      | page performance.
    p Click on the #[em animate] to change its state.
    p Click on #[em code] to view and modify its code.

  template(v-slot:interface)
    div #[strong Properties:]
      ul
        +prop("iframe") iframe protected mode
        +prop("src") load external resource (uses iframe mode)
        +prop("state") input state binding
        +prop("preserveAspectRatio") modify #[tt preserveAspectRatio] attribute on svg element

    div #[strong Methods:]
      ul
        +prop("reload(): void") reload the SSVG document
        +prop("updateState(state: any): void") update current state
        +prop("getState(): any") get current SSVG state

    div #[strong Slots:]
      ul
        +prop("default") an SSVG document (will be overriden if #[tt src] is set)

      div
        | #[strong.text-info Note:] when using an iframe, the root #[tt svg] node
        | is mandatory.

      div
        | #[strong.text-info Note:] iframes can't overflow the parent document.
  template(v-slot:code)
    template(v-pre).
      .row
        BaseSSVG.px-1(:state='{ range: state }' width='50%' height='100%'
                      :src='$butils.publicPath("img/ssvg-logo.svg")')

        BaseSSVG.px-1(:state='{ count: state }' width='50%' height='100%' :iframe='true' style="overflow: visible;")
          svg(width='100%' height='100%' style="overflow: visible;")
            state
              transition(v-pre duration='1s')
              property(name="count" type="number" min="0" max="2")
                relation(attribute-name="fill" query-selector="rect" from="rgb(255, 177, 59)" to="pink")
                relation(attribute-name="stroke-width" query-selector="rect" from="0" to="2em")
                relation(attribute-name="rx" query-selector="rect" from="0" to="50%")
                relation(query-selector=".value" from="0" to="2")
                  transition(v-pre duration="0")
            rect(fill='blue' width='100%' height='100%' stroke='red')
            text(text-anchor="middle" x="50%" y="50%")
              tspan SSVG iframe integration
              tspan(dy='1em' x='50%') value: \#[tspan.value ?]
</template>
<script>

import Example from "./AppExample.vue";

export default {
  name: "ExampleSSVGIFrame",
  components: { Example }
};

</script>
